# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.category import Category  # noqa: F401,E501
from swagger_server.models.pet import Pet  # noqa: F401,E501
from swagger_server.models.tag import Tag  # noqa: F401,E501
from swagger_server import util


class Dog(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, id: int=None, category: Category=None, name: str=None, photo_urls: List[str]=None, tags: List[Tag]=None, status: str=None, bark: bool=None, breed: str=None):  # noqa: E501
        """Dog - a model defined in Swagger

        :param id: The id of this Dog.  # noqa: E501
        :type id: int
        :param category: The category of this Dog.  # noqa: E501
        :type category: Category
        :param name: The name of this Dog.  # noqa: E501
        :type name: str
        :param photo_urls: The photo_urls of this Dog.  # noqa: E501
        :type photo_urls: List[str]
        :param tags: The tags of this Dog.  # noqa: E501
        :type tags: List[Tag]
        :param status: The status of this Dog.  # noqa: E501
        :type status: str
        :param bark: The bark of this Dog.  # noqa: E501
        :type bark: bool
        :param breed: The breed of this Dog.  # noqa: E501
        :type breed: str
        """
        self.swagger_types = {
            'id': int,
            'category': Category,
            'name': str,
            'photo_urls': List[str],
            'tags': List[Tag],
            'status': str,
            'bark': bool,
            'breed': str
        }

        self.attribute_map = {
            'id': 'id',
            'category': 'category',
            'name': 'name',
            'photo_urls': 'photoUrls',
            'tags': 'tags',
            'status': 'status',
            'bark': 'bark',
            'breed': 'breed'
        }
        self._id = id
        self._category = category
        self._name = name
        self._photo_urls = photo_urls
        self._tags = tags
        self._status = status
        self._bark = bark
        self._breed = breed

    @classmethod
    def from_dict(cls, dikt) -> 'Dog':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Dog of this Dog.  # noqa: E501
        :rtype: Dog
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Dog.


        :return: The id of this Dog.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Dog.


        :param id: The id of this Dog.
        :type id: int
        """

        self._id = id

    @property
    def category(self) -> Category:
        """Gets the category of this Dog.


        :return: The category of this Dog.
        :rtype: Category
        """
        return self._category

    @category.setter
    def category(self, category: Category):
        """Sets the category of this Dog.


        :param category: The category of this Dog.
        :type category: Category
        """

        self._category = category

    @property
    def name(self) -> str:
        """Gets the name of this Dog.


        :return: The name of this Dog.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this Dog.


        :param name: The name of this Dog.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def photo_urls(self) -> List[str]:
        """Gets the photo_urls of this Dog.


        :return: The photo_urls of this Dog.
        :rtype: List[str]
        """
        return self._photo_urls

    @photo_urls.setter
    def photo_urls(self, photo_urls: List[str]):
        """Sets the photo_urls of this Dog.


        :param photo_urls: The photo_urls of this Dog.
        :type photo_urls: List[str]
        """
        if photo_urls is None:
            raise ValueError("Invalid value for `photo_urls`, must not be `None`")  # noqa: E501

        self._photo_urls = photo_urls

    @property
    def tags(self) -> List[Tag]:
        """Gets the tags of this Dog.


        :return: The tags of this Dog.
        :rtype: List[Tag]
        """
        return self._tags

    @tags.setter
    def tags(self, tags: List[Tag]):
        """Sets the tags of this Dog.


        :param tags: The tags of this Dog.
        :type tags: List[Tag]
        """

        self._tags = tags

    @property
    def status(self) -> str:
        """Gets the status of this Dog.

        pet status in the store  # noqa: E501

        :return: The status of this Dog.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this Dog.

        pet status in the store  # noqa: E501

        :param status: The status of this Dog.
        :type status: str
        """
        allowed_values = ["available", "pending", "sold"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def bark(self) -> bool:
        """Gets the bark of this Dog.


        :return: The bark of this Dog.
        :rtype: bool
        """
        return self._bark

    @bark.setter
    def bark(self, bark: bool):
        """Sets the bark of this Dog.


        :param bark: The bark of this Dog.
        :type bark: bool
        """

        self._bark = bark

    @property
    def breed(self) -> str:
        """Gets the breed of this Dog.


        :return: The breed of this Dog.
        :rtype: str
        """
        return self._breed

    @breed.setter
    def breed(self, breed: str):
        """Sets the breed of this Dog.


        :param breed: The breed of this Dog.
        :type breed: str
        """
        allowed_values = ["Dingo", "Husky", "Retriever", "Shepherd"]  # noqa: E501
        if breed not in allowed_values:
            raise ValueError(
                "Invalid value for `breed` ({0}), must be one of {1}"
                .format(breed, allowed_values)
            )

        self._breed = breed
